/*=========================================================================
 *
 *  Copyright Insight Software Consortium
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0.txt
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 *=========================================================================*/
/*=========================================================================
 *
 *  Portions of this file are subject to the VTK Toolkit Version 3 copyright.
 *
 *  Copyright (c) Ken Martin, Will Schroeder, Bill Lorensen
 *
 *  For complete copyright, license and disclaimer of warranty information
 *  please refer to the NOTICE file at the top of the ITK source tree.
 *
 *=========================================================================*/

#ifndef itk_minc2_h
#define itk_minc2_h

/* Use the LIBMINC library configured for ITK.  */
/* #undef ITK_USE_SYSTEM_MINC */

#ifndef HAVE_MINC1
/* #undef HAVE_MINC1 */
#endif /*HAVE_MINC1*/

#ifdef ITK_USE_SYSTEM_MINC
# include <minc2.h>
# include <volume_io.h>
#else
# include "minc2.h"
# include "volume_io.h"
#endif

#endif
