#ifndef itk_nifti_mangle_h
#define itk_nifti_mangle_h

/*
This header file mangles all function names exported from the nifti library.
It is intended to be included by ITK's version "nifti1.h".
*/

#define disp_nifti_1_header itk_disp_nifti_1_header
#define is_nifti_file itk_is_nifti_file
#define is_valid_nifti_type itk_is_valid_nifti_type
#define nifti_add_extension itk_nifti_add_extension
#define nifti_compiled_with_zlib itk_nifti_compiled_with_zlib
#define nifti_convert_nhdr2nim itk_nifti_convert_nhdr2nim
#define nifti_convert_nim2nhdr itk_nifti_convert_nim2nhdr
#define nifti_copy_extensions itk_nifti_copy_extensions
#define nifti_copy_nim_info itk_nifti_copy_nim_info
#define nifti_datatype_from_string itk_nifti_datatype_from_string
#define nifti_datatype_is_valid itk_nifti_datatype_is_valid
#define nifti_datatype_sizes itk_nifti_datatype_sizes
#define nifti_datatype_string itk_nifti_datatype_string
#define nifti_datatype_to_string itk_nifti_datatype_to_string
#define nifti_disp_lib_hist itk_nifti_disp_lib_hist
#define nifti_disp_lib_version itk_nifti_disp_lib_version
#define nifti_disp_matrix_orient itk_nifti_disp_matrix_orient
#define nifti_disp_type_list itk_nifti_disp_type_list
#define nifti_extension_size itk_nifti_extension_size
#define nifti_fileexists itk_nifti_fileexists
#define nifti_find_file_extension itk_nifti_find_file_extension
#define nifti_findhdrname itk_nifti_findhdrname
#define nifti_findimgname itk_nifti_findimgname
#define nifti_free_extensions itk_nifti_free_extensions
#define nifti_free_NBL itk_nifti_free_NBL
#define nifti_get_filesize itk_nifti_get_filesize
#define nifti_get_intlist itk_nifti_get_intlist
#define nifti_get_volsize itk_nifti_get_volsize
#define nifti_hdr_looks_good itk_nifti_hdr_looks_good
#define nifti_image_free itk_nifti_image_free
#define nifti_image_from_ascii itk_nifti_image_from_ascii
#define nifti_image_infodump itk_nifti_image_infodump
#define nifti_image_load itk_nifti_image_load
#define nifti_image_load_bricks itk_nifti_image_load_bricks
#define nifti_image_open itk_nifti_image_open
#define nifti_image_read itk_nifti_image_read
#define nifti_image_read_bricks itk_nifti_image_read_bricks
#define nifti_image_to_ascii itk_nifti_image_to_ascii
#define nifti_image_unload itk_nifti_image_unload
#define nifti_image_write itk_nifti_image_write
#define nifti_image_write_bricks itk_nifti_image_write_bricks
#define nifti_image_write_hdr_img itk_nifti_image_write_hdr_img
#define nifti_image_write_hdr_img2 itk_nifti_image_write_hdr_img2
#define nifti_intent_string itk_nifti_intent_string
#define nifti_is_complete_filename itk_nifti_is_complete_filename
#define nifti_is_gzfile itk_nifti_is_gzfile
#define nifti_is_inttype itk_nifti_is_inttype
#define nifti_is_valid_datatype itk_nifti_is_valid_datatype
#define nifti_is_valid_ecode itk_nifti_is_valid_ecode
#define nifti_make_new_header itk_nifti_make_new_header
#define nifti_make_new_nim itk_nifti_make_new_nim
#define nifti_make_orthog_mat44 itk_nifti_make_orthog_mat44
#define nifti_makebasename itk_nifti_makebasename
#define nifti_makehdrname itk_nifti_makehdrname
#define nifti_makeimgname itk_nifti_makeimgname
#define nifti_mat33_colnorm itk_nifti_mat33_colnorm
#define nifti_mat33_determ itk_nifti_mat33_determ
#define nifti_mat33_inverse itk_nifti_mat33_inverse
#define nifti_mat33_mul itk_nifti_mat33_mul
#define nifti_mat33_polar itk_nifti_mat33_polar
#define nifti_mat33_rownorm itk_nifti_mat33_rownorm
#define nifti_mat44_inverse itk_nifti_mat44_inverse
#define nifti_mat44_to_orientation itk_nifti_mat44_to_orientation
#define nifti_mat44_to_quatern itk_nifti_mat44_to_quatern
#define nifti_nim_has_valid_dims itk_nifti_nim_has_valid_dims
#define nifti_nim_is_valid itk_nifti_nim_is_valid
#define nifti_orientation_string itk_nifti_orientation_string
#define nifti_quatern_to_mat44 itk_nifti_quatern_to_mat44
#define nifti_read_ascii_image itk_nifti_read_ascii_image
#define nifti_read_buffer itk_nifti_read_buffer
#define nifti_read_collapsed_image itk_nifti_read_collapsed_image
#define nifti_read_header itk_nifti_read_header
#define nifti_read_subregion_image itk_nifti_read_subregion_image
#define nifti_set_allow_upper_fext itk_nifti_set_allow_upper_fext
#define nifti_set_debug_level itk_nifti_set_debug_level
#define nifti_set_filenames itk_nifti_set_filenames
#define nifti_set_iname_offset itk_nifti_set_iname_offset
#define nifti_set_skip_blank_ext itk_nifti_set_skip_blank_ext
#define nifti_set_type_from_names itk_nifti_set_type_from_names
#define nifti_short_order itk_nifti_short_order
#define nifti_simple_init_nim itk_nifti_simple_init_nim
#define nifti_slice_string itk_nifti_slice_string
#define nifti_strdup itk_nifti_strdup
#define nifti_swap_16bytes itk_nifti_swap_16bytes
#define nifti_swap_2bytes itk_nifti_swap_2bytes
#define nifti_swap_4bytes itk_nifti_swap_4bytes
#define nifti_swap_8bytes itk_nifti_swap_8bytes
#define nifti_swap_as_analyze itk_nifti_swap_as_analyze
#define nifti_swap_Nbytes itk_nifti_swap_Nbytes
#define nifti_test_datatype_sizes itk_nifti_test_datatype_sizes
#define nifti_type_and_names_match itk_nifti_type_and_names_match
#define nifti_units_string itk_nifti_units_string
#define nifti_update_dims_from_array itk_nifti_update_dims_from_array
#define nifti_validfilename itk_nifti_validfilename
#define nifti_write_all_data itk_nifti_write_all_data
#define nifti_write_ascii_image itk_nifti_write_ascii_image
#define nifti_write_buffer itk_nifti_write_buffer
#define nifti_xform_string itk_nifti_xform_string
#define old_swap_nifti_header itk_old_swap_nifti_header
#define swap_nifti_header itk_swap_nifti_header
#define valid_nifti_brick_list itk_valid_nifti_brick_list
#define valid_nifti_extensions itk_valid_nifti_extensions


#endif
